#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/time.h>
#include "main.h"
#include "graphe.h"
#include "algo.h"
#include "lc.hpp"
EuclidianGraphe * CurrentGraphe;
Result * Results;
unsigned long CurrentOptions;
int Command(char * buffer);
void main(int argc,char * argv[])
{
  /*
  EuclidianGraphe *eg=new EuclidianGraphe(500);
  eg->Randomise(100,10);
  eg->InitDrawing(argc,argv);
  //eg->Draw(NULL);
  //tArretes * circuit= PVC_HPlusProcheVoisin(eg,100+0x30000);
  tArretes * circuit= PVC_HMoindreCout(eg,1+0x30000);
  printf(" press a key to stop");
  getchar();
  return 0;*/
  //EuclidianGraphe::InitDrawing(argc,argv);
  CurrentOptions=0;
  CurrentGraphe=NULL;
  Results=NULL;
  char buffer[1000];
  printf("Taper \"?\" pour avoir la liste des commandes\n");
  //boucle principale
  while(1)
    {
      printf("\n>");
      gets(buffer);
      if (buffer[0]==EOF) exit(0);
      if (!Command(buffer)) exit(0);
    }
}
int Command(char * buffer)
{
  if ( (!strcasecmp(buffer,"quit"))||  (!strcasecmp(buffer,"x")) ) return 0;
  if ( (!strcasecmp(buffer,"help"))||  (!strcasecmp(buffer,"h"))||(!strcmp(buffer,"?")) )
    {
      printf("Utilisation du programme:\n"   
	     "  1) charger une instance d'un PVC\n"
	     "  2) appliquer diffrents algorithmes ou heuristiques de rsolution\n"
	     "  3) sauvegarder les resultats\n\n"
	     "POUR CHARGER UN PROBLEME:\n"
	     "  \"random n range facteur\"  ou n est le nombre de villes, range la"
	     "coordonnee maximale de chaque point, et facteur le facteur multiplicatif"
	     "applique avant le calcul de distance\n"
	     "  \"load fichier\"  charge un probleme contenu dans le fichier specife, qui "
	     "doit etre au format utilis par TSPLIB\n\n"
	     "POUR RESOUDRE UN PROBLEME:\n"
	     "  \"list\"  numre les algorithmes ou heuristiques disponibles\n"
	     "  \"solve algo options\" applique l'algorithme specifie (par son nom ou son numero) au probleme actuel"
	     "la valeur numerique options est passee en parametre a l'algorithme. Il est "
	     "possible de spcifier 'A' ou 'H' pour appliquer tous les algorithmes"
	     "ou uniquement les heuristiques, respectivement.\n\n"
	     "OPTIONS DIVERSES:\n"
	     "  \"draw interval\" un interval nul signifie pas d'affichage. Une valeure non"
	     " nulle dfinit le nombre de pas de 10 milisecondes a atendre aprs chaque image\n"
	     "  \"output n\" n dfinit le niveau de details des informations envoyes sur la console voulu. Les valeurs vont de 0 pour aucun a 4 pour debug\n\n"
	     "AFFICHAGE DES RESULTATS:\n"
	     "  \"show\"  affiche tous les resultats obtenus sur le probleme actuel\n"
	     "  \"view id\" affiche graphiquement la solution numero id\n"
	     "SAUVEGARDER ET QUITTER:\n"
	     "  \"save fichier [algo] \" sauvegarde dans le fichier specifie la meilleure solution trouvee en se limitant aux resultats trouves par algo si ce paramtre est specifie\n"
	     "  \"quit\" ou \"x\" quitte le programme\n");
      return 1;
    }
  if (!strncasecmp(buffer,"random ",strlen("random ")))
    {
      unsigned long s,range,factor;
      if (sscanf(&buffer[strlen("random ")],"%u%u%u",&s,&range,&factor)!=3)
	{
	  printf("\nerreur de syntaxe: cette commande prend trois paramtres entiers\n");
	  return 1;;
	}
      //on flush tout
      EradicateLC<Result>(Results);
      Results=NULL;
      delete CurrentGraphe;
      CurrentGraphe=NULL;
      //on cree
      CurrentGraphe=new EuclidianGraphe(s);
      CurrentGraphe->Randomise(range,factor);
      return 1;
    }
  if (!strcasecmp(buffer,"list"))
    {
      printf("\nListe des algorithmes disponibles:\n");
      for (int i=0;Algorithmes[i].Name;i++)
	{
	  printf("%d  %s : %s\n",i,Algorithmes[i].Name,Algorithmes[i].Description);
	}
      return 1;
    }
  if (!strncasecmp(buffer,"solve ",strlen("solve ")))
    {
      char algo[50];
      unsigned long options=0;
      if (sscanf(&buffer[strlen("solve ")],"%s%u",algo,&options)<1)
	{
	  printf("\nerreur de syntaxe: cette commande prend deux  paramtres\n");
	  return 1;
	}
      if (!CurrentGraphe)
	{
	      printf("\nAucun problme charg\n");
	      return 1;
	}
      //on localise l'algorithme
      unsigned long doall=0;
      if ((algo[0]=='H')&&(algo[1]==0))
	{
	  doall=1;
	}
      if ((algo[0]=='A')&&(algo[1]==0))
	{
	  doall=2;
	}
      if (doall)
	{
	  char subbuffer[200];
	  for (int i=0;Algorithmes[i].Name;i++)
	    {
	      if ((doall==1)&&(Algorithmes[i].Name[0]=='A')) continue;
	      sprintf(subbuffer,"solve %u %u",i,options);
	      Command(subbuffer);
	    }
	  return 1;
	}
      unsigned long algoid=-1;
      if ((algo[0]>='0')&&(algo[0]<='9'))
	algoid=strtol(algo,NULL,0);
      else
	{
	  bool found=false;
	  for (int i=0;Algorithmes[i].Name;i++)
	    {
	      if (!strcasecmp(Algorithmes[i].Name,algo))
		{
		  found=true;
		  algoid=i;
		  break;
		}
	      if (found) break;
	    }
	  if (!found) printf("algorithme %s non trouv, taper \"list\" pour avoir la liste des algorithmes\n",algo);
	}
      if (algoid==-1) return 1;
      timeval t1,t2;
      printf("\nexecution de %s(%x)\n",Algorithmes[algoid].Name,CurrentOptions+(options<<24));
      gettimeofday(&t1,NULL);
      tArretes *ta=Algorithmes[algoid].Execute(CurrentGraphe,CurrentOptions+(options<<24));
      gettimeofday(&t2,NULL);
      if (!ta)
	{
	  printf("\nune erreur est surevenue\n");
	  return 1;
	}
      Result *r=new Result();
      r->InitLC();
      r->Algo=Algorithmes[algoid].Name;
      r->Chemin=ta;
      r->Length=CurrentGraphe->Eval(ta);
      r->CalcTime=(t2.tv_sec-t1.tv_sec)*1000+(t2.tv_usec-t1.tv_usec)/1000;
      if (Results) Results->AddElement(r);
      else Results=r;
      return 1;
    }
  if (!strncasecmp(buffer,"draw ",strlen("draw ")))
    {
      unsigned long interval;
      if (sscanf(&buffer[strlen("draw ")],"%u",&interval)!=1)
	{
	  printf("\nerreur de syntaxe: cette commande prend un  paramtre\n");
	  return 1;
	}
      CurrentOptions=(CurrentOptions&0x00ff0000)+(interval&0xffff);
      return 1;
    }
  if (!strncasecmp(buffer,"output ",strlen("output ")))
    {
      unsigned long level;
      if (sscanf(&buffer[strlen("output ")],"%u",&level)!=1)
	{
	  printf("\nerreur de syntaxe: cette commande prend un  paramtre\n");
	  return 1;
	}
      CurrentOptions=(CurrentOptions&0x0000ffff)+((level<<16)&0xff0000);
      return 1;
    }
  if (!strcasecmp(buffer,"show"))
    {
      printf("\nId Algorithme         Chemin   Temp\n");
      int id=0;
      for (Result *r=Results;r;r=(Result *)r->GetNext())
	{
	  printf("%2u%20s%9u%9u\n",id,r->Algo,r->Length,r->CalcTime);
	  id++;
	}
      return 1;
    }
  if (!strncasecmp(buffer,"view ",strlen("view ")))
    {
      unsigned long id;
      if (sscanf(&buffer[strlen("view ")],"%u",&id)<1)
	{
	  printf("\nerreur de syntaxe: cette commande prend un paramtre\n");
	  return 1;
	}
      Result *r=Results;
      for (;(id)&&(r);r=(Result *)r->GetNext())
	{
	  id--;
	}
      if (!r)
	{
	  printf("\nerreur: indice de rsultat trop grand\n");
	  return 1;
	}
      CurrentGraphe->Draw(r->Chemin);
      return 1;
    }
  //commande non reconnue
  printf("\n command non reconnue, taper ? pour avoir la liste des commandes\n");
  return 1;
}
