#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include "synchronizer.h"
//#define DEBUG 1
synchronizer * synchronizer_new()
{
  synchronizer *s=(synchronizer *)malloc(sizeof(synchronizer));
  sem_init(&s->internal,0,1);
  sem_init(&s->sigwait,0,0);
  sem_init(&s->waitwait,0,0);
  s->sigwaiters=0;
  s->waitwaitcount=0;
  return s;
}

void synchronizer_waitforsignal(synchronizer * sync)
{
#ifdef DEBUG
  printf("synchronizer_waitforsignal() sigwaiters %d\n",sync->sigwaiters);
#endif
  sem_wait(&sync->internal);
  sync->sigwaiters++;
  if ((sync->waitwaitcount)&&(sync->sigwaiters>=sync->waitwaitcount) )
    {
      sem_post(&sync->waitwait);
      sync->waitwaitcount=0;
    }
  sem_post(&sync->internal);
  sem_wait(&sync->sigwait);
}

void synchronizer_signal(synchronizer * sync)
{
  sem_wait(&sync->internal);
  while (sync->sigwaiters)
    {//!! on ne peut se contenter de faire autant de post qu'il y a de thread bloques car alors un thread pourrait se reveiller, et ne pas se faire bloquer par son prochain appel de waitforsignal
      sync->sigwaiters--;
      sem_post(&sync->sigwait);
      int v=1;
      while (v) {v=sem_getvalue(&sync->sigwait,&v);usleep(1);}
    }

  sem_post(&sync->internal);
}

bool synchronizer_waitforwaiters(synchronizer * sync,unsigned long waiterslimit)
{
#ifdef DEBUG
  printf("synchronizer_waitforwaiters() sigwaiters %d\n",sync->sigwaiters);
#endif
  sem_wait(&sync->internal);
  if (sync->waitwaitcount)
    {
      sem_post(&sync->internal);
      return false;
    }
  if (waiterslimit<=sync->sigwaiters)
    {
      sem_post(&sync->internal);
      return true;
    }
sync->waitwaitcount=waiterslimit;
 sem_post(&sync->internal);
 sem_wait(&sync->waitwait);
}

void synchronizer_destroy(synchronizer * sync)
{
  sem_destroy(&sync->internal);
  sem_destroy(&sync->waitwait);
  sem_destroy(&sync->sigwait);
  free(sync);
}
