//xtree.hpp
//DO NOT INCLUDE,USE RATHER xtree.h
//template<class TR> TR * rFind(TR * Root,void * data,DWORD Param);
template <class TR> TR * rFind(TR * Root,void * data,DWORD Param)
    {
    if (!Root) return NULL;
    if (Root->CompareData(data,Param)) return Root;
    for (TR * tr=Root->Child;tr ;tr=tr->Next)
        {
        TR * ttr=rFind<TR>(tr,data,Param);
        if (ttr) return ttr;
        }
    return NULL;
    }
template<class TR>  TR * Find(TR * Root,void * data,DWORD Param)
    {
    if (!Root)return NULL;
    for (TR * tr=Root;tr ;tr=(TR *)tr->Next)
        {
        TR * ttr=rFind<TR>(tr,data,Param);
        if (ttr) return ttr;
        }
    return NULL;
    }

//template<class TR> DWORD rSumResults(TR * Root,DWORD (TR::func)(DWORD Param,void * Data),DWORD Param,void * Data );
template<class TR> DWORD SumResults(TR * Root,DWORD Param,void * Data )
    {
    DWORD r=0;
    if (!Root) return 0;
    for (TR * tr=Root;tr ;tr=(TR *)tr->Next)
        {
        r+=rSumResults(tr,Param,Data);
        }
    return r;
    }
template<class TR> DWORD rSumResults(TR * Root,DWORD Param,void * Data )
    {
    DWORD r=0;
    r=Root->Data(Param,Data);
    for (TR * tr=(TR *)Root->Child;tr ;tr=(TR *)tr->Next)
        {
        r+=rSumResults<TR>(tr,Param,Data);
        }
    return r;
    }
template<class TR> TR * SafeCall(TR * Root,DWORD Param,void * Data )
    {
    if (!Root) return 0;
	TR * tr=Root;
	TR * ttr=tr;
	TR * good=NULL;
	bool deleted=false;
    while (ttr)
        {
		tr=ttr;
		ttr=(TR *)tr->Next;
        deleted=!rSafeCall(tr,Param,Data);
		if ((!deleted)&&(!good)) good=tr;
        }
	return good;
    }
template<class TR> bool rSafeCall(TR * Root,DWORD Param,void * Data )
    { 
    Root->Child=SafeCall<TR>((TR *)Root->Child,Param,Data);
	return Root->Data(Param,Data);
    }

template<class TR> TR * Eradicate(TR * Root )
{
  if (!Root) return NULL;
  if (Root->Child) Eradicate((TR *)Root->Child);
  if (Root->Next) Eradicate((TR *)Root->Next);
  Root->Child=Root->Prev=Root->Next=NULL;
  delete Root;
  return NULL;
}

template<class TR> void rSave(TR * Root,DWORD &A1,DWORD &A2)
    {
	TR * prev=NULL;
    for (TR * tr=(TR *)Root->Child;tr ;tr=(TR *)tr->Next)
        {
		CopyMemory((void *)A1,tr,sizeof(TR));
		TR * nr=(TR *)A1;
		A1+=sizeof(TR);
		if (!prev) Root->Child=nr;
		nr->LoadSaveOp(OP_WRITEDATA,&A2);
		nr->Parent=Root;
		nr->Prev=prev;
		if (prev) prev->Next=nr;
		prev=nr;
        rSave<TR>(nr,A1,A2);
        }
    }
template<class TR> TData *Save(TR * Root)
    {
	//note: marche pas:reecrire rsave en traitant les childs
    if (!Root) return NULL;
    DWORD ts=SumResults<TR>(Root,DAT_REDIR+OP_GETSIZE,NULL);
    DWORD ec=Root->Count();
    DWORD toal=ts+ec*sizeof(TR);
    void * Buff=LocalAlloc(LMEM_FIXED|LMEM_ZEROINIT,toal+8);
    *((DWORD *)Buff)=ec;
    *((DWORD *)((DWORD)Buff+4))=(DWORD)Buff;
    DWORD Addr=(DWORD)Buff+8;
    DWORD Addr2=Addr+ec*sizeof(TR);//debut des datos
	TR * prev=NULL;
    for (TR * tr=Root;tr ;tr=(TR *)tr->Next)
        {
		CopyMemory((void *)Addr,tr,sizeof(TR));
		TR * nr=(TR *)Addr;
		Addr+=sizeof(TR);
		nr->LoadSaveOp(OP_WRITEDATA,&Addr2);
		nr->Prev=prev;
		if (prev) prev->Next=nr;
		prev=nr;
        rSave<TR>(nr,Addr,Addr2);
        }
    if (Addr-(DWORD)Buff!=8+ec*sizeof(TR)) MessageBox(NULL,"fatal error","fatal error",0);
    TData * dat=new TData;
    dat->Size=toal+8;
    dat->Data=Buff;
    return dat;
    }
/*
template<class TR> void rSave(TR * Root,DWORD &A1,DWORD &A2)
    {
	//!!ne rien changer en bas  droite!!
    //dabord soi puis ses enfants comme d'hab
    CopyMemory((void *)A1,Root,sizeof(TR));
    TR * nr=(TR *)A1;
	A1+=sizeof(TR);
    if (nr->Prev)
        {
        nr->Parent=nr->Prev->Parent;
        nr->Prev->Next=nr;
        }
	else 
		{
		if (nr->Parent) nr->Parent->Child=nr;
		}
	//***<erreur>
    //if (nr->Next) nr->Next->Prev=nr;
    //if (nr->Child) nr->Child->Parent=nr;
	//***</erreur>
    //les datos
    nr->LoadSaveOp(OP_WRITEDATA,&A2);
    for (TR * tr=(TR *)Root->Child;tr ;tr=(TR *)tr->Next)
        {
        rSave<TR>(tr,A1,A2);
        }
    }
template<class TR> TData *Save(TR * Root)
    {
	//note: marche pas:reecrire rsave en traitant les childs
    if (!Root) return NULL;
    DWORD ts=SumResults<TR>(Root,DAT_REDIR+OP_GETSIZE,NULL);
    DWORD ec=Root->Count();
    DWORD toal=ts+ec*sizeof(TR);
    void * Buff=LocalAlloc(LMEM_FIXED,toal+8);
    *((DWORD *)Buff)=ec;
    *((DWORD *)((DWORD)Buff+4))=(DWORD)Buff;
    DWORD Addr=(DWORD)Buff+8;
    DWORD Addr2=Addr+ec*sizeof(TR);//debut des datos
    for (TR * tr=Root;tr ;tr=(TR *)tr->Next)
        {
        rSave<TR>(tr,Addr,Addr2);
        }
    if (Addr-(DWORD)Buff!=8+ec*sizeof(TR)) MessageBox(NULL,"fatal error","fatal error",0);
    TData * dat=new TData;
    dat->Size=toal+8;
    dat->Data=Buff;
    return dat;
    }*/


template<class TR> TR * Load(void * data)
    {
    //ya juste  bidouiller quelques addresses
    //DWORD cnt=*((DWORD *)data);
    DWORD olda=*((DWORD *)((DWORD)data+4));
    TR * Root=(TR *)((DWORD)data+8);
    SumResults<TR>(Root,OP_DELTADATA+DAT_REDIR,(void *)((DWORD)data-olda));
    return Root;
    }
